/*********************************************************************
THIS SOURCE CODE IS SUPPLIED "AS IS" WITHOUT WARRANTY OF ANY KIND, AND
ITS AUTHOR AND THE JOURNAL OF ARTIFICIAL INTELLIGENCE RESEARCH (JAIR)
AND JAIR'S PUBLISHERS AND DISTRIBUTERS, DISCLAIM ANY AND ALL WARRANTIES,
INCLUDING BUT NOT LIMITED TO ANY IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS FOR A PARTICULAR PURPOSE, AND ANY WARRANTIES OR NON
INFRINGEMENT.  THE USER ASSUMES ALL LIABILITY AND RESPONSIBILITY FOR
USE OF THIS SOURCE CODE AND NEITHER THE AUTHOR NOR JAIR, NOR JAIR'S
PUBLISHERS AND DISTRIBUTORS, WILL BE LIABLE FOR DAMAMAGES OF ANY KIND
RESULTING FROM ITS USE.  Without limiting the generality of the
foregoing, neither the author, nor JAIR, nor JAIR's publishers and
distributors, warrant that the source code will be error-free, will
operate without interruption, or will meet the needs of the user.
**********************************************************************/

/* Copyright J.R. Quinlan, 1989, 1990, 1991, 1992.
** Distributed with permission.
*/

/*************************************************************************/
/*									 */
/*		Global Data for C4.5					 */
/*		--------------------					 */
/*									 */
/*************************************************************************/


extern  short		MaxAtt,		/* max att number */
			MaxClass,	/* max class number */
			MaxDiscrVal;	/* max discrete values for any att */

extern  ItemNo		MaxItem;	/* max data item number */

extern  Description	*Item;		/* data items */

extern  DiscrValue	*MaxAttVal;	/* number of values for each att */

extern  char		*SpecialStatus;	/* special att treatment */

extern  String		*ClassName,	/* class names */
		  	*AttName,	/* att names */
		  	**AttValName,	/* att value names */
			FileName;	/* family name of files */

extern  Boolean		AllKnown;	/* true if there have been no splits
					   on atts with missing values above
					   the current position in the tree */


/*************************************************************************/
/*									 */
/*		Global Parameters for C4.5				 */
/*									 */
/*************************************************************************/


extern  short		VERBOSITY,	/* verbosity level (0 = none) */
			TRIALS;		/* number of trees to be grown */

extern  Boolean		GAINRATIO,	/* true=gain ratio, false=gain */
			SUBSET,		/* true if subset tests allowed */
			BATCH,		/* true if windowing turned off */
			UNSEENS,	/* true if to evaluate on test data */
			PROBTHRESH;	/* true if to use soft thresholds */

extern  ItemNo		MINOBJS,	/* minimum items each side of a cut */
			WINDOW,		/* initial window size */
			INCREMENT;	/* max window increment each iteration */

extern  float		CF;		/* confidence limit for tree pruning */

extern  ClassNo		RESULTCLASS;	/* class for which to print TP etc */

extern Boolean		POSTPROCESS;
